您的位置:首页 > 其它

[leetcode] 292. Nim Game 解题报告

2015-12-29 17:29 585 查看
题目链接:https://leetcode.com/problems/nim-game/

You are playing the following Nim Game with your friend: There is a heap of stones on the table, each time one of you take turns to remove 1 to 3 stones. The one who removes the last stone will be the winner. You will take the first turn to remove the stones.

Both of you are very clever and have optimal strategies for the game. Write a function to determine whether you can win the game given the number of stones in the heap.

For example, if there are 4 stones in the heap, then you will never win the game: no matter 1, 2, or 3 stones you remove, the last stone will always be removed by your friend.

Hint:

If there are 5 stones in the heap, could you figure out a way to remove the stones such that you will always be the winner?

思路:一道博弈论的题目。题意是两人交替从石头堆里取石子,一次可以取1-3个,谁最后拿完谁赢。有以下情况:

n = 1: 先拿的必胜

n = 2: 先拿的必胜

n = 3: 先拿的必胜

n = 4: 先拿的必败

n = 5: 可以先手拿一个,让对手面临n=4的状况,所以先手必胜

n = 6: 先手拿2个,让对手面临n = 4的状况,所以先手必胜

n = 7: 先手拿3个,让对手面临n = 4的状况,所以先手必胜

n = 8: 先手不管拿几个,对手都会让你陷入n = 4的状况,因此先手必败。

....

可知当n为4的倍数时,先手是必败的。也就是说你如果想要赢,你要做的就是把剩余的石子数变为4的倍数。

唔!终于把easy题做完了!到达124了,现在题目总共306道,阶段性任务已经完成,还有很长的路要走。


代码如下:

class Solution {
public:
bool canWinNim(int n) {
if(n % 4 == 0) return false;
else return true;
}
};
参考:http://blog.csdn.net/ironyoung/article/details/49100457
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: